## openigtlink 1.0.0~svn3987

=== Examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.4)

#
# Examples
#


## Imager program isn't supported by QNX

if(NOT OpenIGTLink_PLATFORM_QNX)
  SUBDIRS(
      Tracker
      Imager
      Status
      Receiver
      )
else(NOT OpenIGTLink_PLATFORM_QNX)
  SUBDIRS(
      Tracker
      Status
      Receiver
      )
endif(NOT OpenIGTLink_PLATFORM_QNX)

=== Testing/CMakeLists.txt ===
ADD_EXECUTABLE(igtlSocketTest   igtlSocketTest.cxx)

INCLUDE_DIRECTORIES( ${OpenIGTLink_SOURCE_DIR}/Source )

TARGET_LINK_LIBRARIES(igtlSocketTest OpenIGTLink)

ADD_TEST(igtlSocketTest ${OpenIGTLink_EXECUTABLE_PATH}/igtlSocketTest)

ADD_SUBDIRECTORY( igtlutil )

=== Testing/igtlutil/CMakeLists.txt ===
ADD_EXECUTABLE(igtl_image_test igtl_image_test.c)
ADD_EXECUTABLE(igtl_header_test igtl_header_test.c)
ADD_EXECUTABLE(igtl_transform_test igtl_transform_test.c)
ADD_EXECUTABLE(igtl_util_test igtl_util_test.c)

TARGET_LINK_LIBRARIES(igtl_image_test OpenIGTLink)
TARGET_LINK_LIBRARIES(igtl_header_test OpenIGTLink)
TARGET_LINK_LIBRARIES(igtl_transform_test OpenIGTLink)
TARGET_LINK_LIBRARIES(igtl_util_test OpenIGTLink)

ADD_TEST( igtl_image_test_01     ${OpenIGTLink_EXECUTABLE_PATH}/igtl_image_test )
ADD_TEST( igtl_header_test_01    ${OpenIGTLink_EXECUTABLE_PATH}/igtl_header_test )
ADD_TEST( igtl_transform_test_01 ${OpenIGTLink_EXECUTABLE_PATH}/igtl_transform_test )
ADD_TEST( igtl_util_test_01      ${OpenIGTLink_EXECUTABLE_PATH}/igtl_util_test )

## openigtlink 1.0.0~svn6270

=== CMakeLists.txt ===
PROJECT( OpenIGTLink )

cmake_minimum_required(VERSION 2.4)

if(COMMAND cmake_policy)
     cmake_policy(SET CMP0003 NEW)
     endif(COMMAND cmake_policy)

ENABLE_TESTING()
INCLUDE (${CMAKE_ROOT}/Modules/Dart.cmake)

#-----------------------------------------------------------------------------
# OpenIGTlink version number.
SET(OpenIGTLink_VERSION_MAJOR "1")
SET(OpenIGTLink_VERSION_MINOR "0")
SET(OpenIGTLink_VERSION_PATCH "0")



#-----------------------------------------------------------------------------
# OpenIGTLink build configuration options.

OPTION(BUILD_SHARED_LIBS "Build OpenIGTLink with shared libraries." OFF)
SET(OpenIGTLink_BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS})

if(NOT OpenIGTLink_BUILD_SHARED_LIBS)
  OPTION(BUILD_GENERATE_PIC "Generate position independent code (for static)." ON)
  SET(OpenIGTLink_BUILD_GENERATE_PIC ${BUILD_GENERATE_PIC})
endif(NOT OpenIGTLink_BUILD_SHARED_LIBS)

OPTION(BUILD_EXAMPLES "Build OpenIGTLink example programs." OFF)
SET(OpenIGTLink_BUILD_EXAMPLES ${BUILD_EXAMPLES})


#-----------------------------------------------------------------------------
# Output directories.

IF(NOT LIBRARY_OUTPUT_PATH)
  SET (LIBRARY_OUTPUT_PATH ${OpenIGTLink_BINARY_DIR}/bin CACHE INTERNAL "Single output directory for building all libraries.")
ENDIF(NOT LIBRARY_OUTPUT_PATH)
IF(NOT EXECUTABLE_OUTPUT_PATH)
  SET (EXECUTABLE_OUTPUT_PATH ${OpenIGTLink_BINARY_DIR}/bin CACHE INTERNAL "Single output directory for building all executables.")
ENDIF(NOT EXECUTABLE_OUTPUT_PATH)
MARK_AS_ADVANCED(LIBRARY_OUTPUT_PATH EXECUTABLE_OUTPUT_PATH)

SET(OpenIGTLink_LIBRARY_PATH "${LIBRARY_OUTPUT_PATH}")
SET(OpenIGTLink_EXECUTABLE_PATH "${EXECUTABLE_OUTPUT_PATH}")


#-----------------------------------------------------------------------------
# Installation vars.
# OpenIGTLink_INSTALL_BIN_DIR          - binary dir (executables)
# OpenIGTLink_INSTALL_LIB_DIR          - library dir (libs)
# OpenIGTLink_INSTALL_DATA_DIR         - share dir (say, examples, data, etc)
# OpenIGTLink_INSTALL_INCLUDE_DIR      - include dir (headers)
# OpenIGTLink_INSTALL_PACKAGE_DIR      - package/export configuration files
# OpenIGTLink_INSTALL_NO_DEVELOPMENT   - do not install development files
# OpenIGTLink_INSTALL_NO_RUNTIME       - do not install runtime files
# OpenIGTLink_INSTALL_NO_DOCUMENTATION - do not install documentation files

IF(NOT OpenIGTLink_INSTALL_BIN_DIR)
  SET(OpenIGTLink_INSTALL_BIN_DIR "bin")
ENDIF(NOT OpenIGTLink_INSTALL_BIN_DIR)

IF(NOT OpenIGTLink_INSTALL_LIB_DIR)
  SET(OpenIGTLink_INSTALL_LIB_DIR "lib/igtl")
ENDIF(NOT OpenIGTLink_INSTALL_LIB_DIR)

IF(NOT OpenIGTLink_INSTALL_DATA_DIR)
  SET(OpenIGTLink_INSTALL_DATA_DIR "share/igtl")
ENDIF(NOT OpenIGTLink_INSTALL_DATA_DIR)

IF(NOT OpenIGTLink_INSTALL_INCLUDE_DIR)
  SET(OpenIGTLink_INSTALL_INCLUDE_DIR "include/igtl")
ENDIF(NOT OpenIGTLink_INSTALL_INCLUDE_DIR)

IF(NOT OpenIGTLink_INSTALL_PACKAGE_DIR)
  SET(OpenIGTLink_INSTALL_PACKAGE_DIR ${OpenIGTLink_INSTALL_LIB_DIR}
    CACHE INTERNAL "")
ENDIF(NOT OpenIGTLink_INSTALL_PACKAGE_DIR)

IF(NOT OpenIGTLink_INSTALL_NO_DOCUMENTATION)
  SET(OpenIGTLink_INSTALL_NO_DOCUMENTATION 0)
ENDIF(NOT OpenIGTLink_INSTALL_NO_DOCUMENTATION)

SET(OpenIGTLink_DIR "${CMAKE_BINARY_DIR}" CACHE INTERNAL "OpenIGTLink dir to be used by subprojects")

#-----------------------------------------------------------------------------
# Include directories

SET(OpenIGTLink_INCLUDE_DIRS_BUILD_TREE ${OpenIGTLink_INCLUDE_DIRS_BUILD_TREE}
  ${OpenIGTLink_BINARY_DIR}
  ${OpenIGTLink_SOURCE_DIR}/Source
  ${OpenIGTLink_SOURCE_DIR}/Source/igtlutil
)

INCLUDE_DIRECTORIES(
  ${OpenIGTLink_INCLUDE_DIRS_BUILD_TREE}
  )

#SET(OpenIGTLink_LIBRARY_PATH  ${OpenIGTLink_LIBRARY_PATH}
#  ${OpenIGTLink_BINARY_DIR}/Source
#  ${OpenIGTLink_BINARY_DIR}/Source/igtlutil
#  )

#-----------------------------------------------------------------------------
# OpenIGTLink requires special compiler flags on some platforms.


INCLUDE (FindThreads)

IF(CMAKE_COMPILER_IS_GNUCXX)
  SET(OpenIGTLink_REQUIRED_C_FLAGS "${OpenIGTLink_REQUIRED_C_FLAGS} -w")
  SET(OpenIGTLink_REQUIRED_CXX_FLAGS "${OpenIGTLink_REQUIRED_CXX_FLAGS} -ftemplate-depth-50")

  # If the library is built as a static library, pass -fPIC option to the compiler
  IF(OpenIGTLink_BUILD_GENERATE_PIC)
    SET(OpenIGTLink_REQUIRED_C_FLAGS "${OpenIGTLink_REQUIRED_C_FLAGS} -fPIC")
    SET(OpenIGTLink_REQUIRED_CXX_FLAGS "${OpenIGTLink_REQUIRED_CXX_FLAGS} -fPIC")
  ENDIF(OpenIGTLink_BUILD_GENERATE_PIC)

  # pthread
  IF(CMAKE_HAVE_THREADS_LIBRARY)
    SET(OpenIGTLink_REQUIRED_LINK_FLAGS "${OpenIGTLink_REQUIRED_LINK_FLAGS} ${CMAKE_THREAD_LIBS_INIT}")
  ENDIF(CMAKE_HAVE_THREADS_LIBRARY)


#  IF(APPLE)
#    # -no-cpp-precomp and -Wno-long-double were compiler flags present
#    # only in Apple's gcc and not in the FSF gcc. The flags are obsolete
#    # and totally removed in gcc 4.2 and later. I believe they are only
#    # needed with gcc 3.3 and earlier.
#    INCLUDE(${OpenIGTLink_SOURCE_DIR}/CMake/itkCheckCXXAcceptsFlags.cmake)
#    itkCHECK_CXX_ACCEPTS_FLAGS("-no-cpp-precomp" CXX_HAS_CPP_PRECOMP_FLAG)
#    IF(CXX_HAS_CPP_PRECOMP_FLAG)    
#      SET(OpenIGTLink_REQUIRED_C_FLAGS "${OpenIGTLink_REQUIRED_C_FLAGS} -no-cpp-precomp")
#      SET(OpenIGTLink_REQUIRED_CXX_FLAGS "${OpenIGTLink_REQUIRED_CXX_FLAGS} -no-cpp-precomp")
#    ENDIF(CXX_HAS_CPP_PRECOMP_FLAG)    
#    itkCHECK_CXX_ACCEPTS_FLAGS("-Wno-long-double" CXX_HAS_LONGDOUBLE_FLAG)
#    IF(CXX_HAS_LONGDOUBLE_FLAG)    
#      SET(OpenIGTLink_REQUIRED_C_FLAGS "${OpenIGTLink_REQUIRED_C_FLAGS} -Wno-long-double")
#      SET(OpenIGTLink_REQUIRED_CXX_FLAGS "${OpenIGTLink_REQUIRED_CXX_FLAGS} -Wno-long-double")
#    ENDIF(CXX_HAS_LONGDOUBLE_FLAG)    
#
#    OPTION(OpenIGTLink_USE_64BITS_APPLE_TRUNCATION_WARNING "Turn on warnings on 64bits to 32bits truncations." OFF)
#    MARK_AS_ADVANCED(OpenIGTLink_USE_64BITS_APPLE_TRUNCATION_WARNING)
#
#  ENDIF(APPLE)
ENDIF(CMAKE_COMPILER_IS_GNUCXX)


# for the gnu compiler a -D_PTHREADS is needed on sun
# for the native compiler a -mt flag is needed on the sun
IF(CMAKE_USE_PTHREADS)
  IF(CMAKE_SYSTEM MATCHES "SunOS.*")
    IF(CMAKE_COMPILER_IS_GNUCXX)
      SET(OpenIGTLink_REQUIRED_CXX_FLAGS "${OpenIGTLink_REQUIRED_CXX_FLAGS} -D_PTHREADS")
    ELSE(CMAKE_COMPILER_IS_GNUCXX)
      SET(OpenIGTLink_REQUIRED_CXX_FLAGS "${OpenIGTLink_REQUIRED_CXX_FLAGS} -mt")
      SET(OpenIGTLink_REQUIRED_C_FLAGS "${OpenIGTLink_REQUIRED_C_FLAGS} -mt")
    ENDIF(CMAKE_COMPILER_IS_GNUCXX)
  ENDIF(CMAKE_SYSTEM MATCHES "SunOS.*")
ENDIF(CMAKE_USE_PTHREADS)


#-----------------------------------------------------------------------------
# Generate Configuration Header files.

include (${OpenIGTLink_SOURCE_DIR}/OpenIGTLinkConfigPlatform.cmake)

CONFIGURE_FILE(${OpenIGTLink_SOURCE_DIR}/igtlConfigure.h.in 
  ${OpenIGTLink_BINARY_DIR}/igtlConfigure.h)

CONFIGURE_FILE(${OpenIGTLink_SOURCE_DIR}/igtl_typeconfig.h.in 
  ${OpenIGTLink_BINARY_DIR}/igtl_typeconfig.h)

CONFIGURE_FILE(${OpenIGTLink_SOURCE_DIR}/igtlTypeConfig.h.in 
  ${OpenIGTLink_BINARY_DIR}/igtlTypeConfig.h)


#-----------------------------------------------------------------------------
# Help other projects use OpenIGTLink.

# Copy the UseOpenIGTLink.cmake file to the binary tree for backward compatability.
CONFIGURE_FILE(${OpenIGTLink_SOURCE_DIR}/UseOpenIGTLink.cmake.in
${OpenIGTLink_BINARY_DIR}/UseOpenIGTLink.cmake COPYONLY IMMEDIATE)

# Create the OpenIGTLinkConfig.cmake file containing the OpenIGTLink configuration.
INCLUDE (${OpenIGTLink_SOURCE_DIR}/GenerateOpenIGTLinkConfig.cmake)

# Save the compiler settings so another project can import them.
INCLUDE(${CMAKE_ROOT}/Modules/CMakeExportBuildSettings.cmake)
CMAKE_EXPORT_BUILD_SETTINGS(${OpenIGTLink_BINARY_DIR}/OpenIGTLinkBuildSettings.cmake)

# Save library dependencies.
#EXPORT_LIBRARY_DEPENDENCIES(${OpenIGTLink_BINARY_DIR}/OpenIGTLinkLibraryDepends.cmake)

INSTALL(FILES
  ${OpenIGTLink_BINARY_DIR}/OpenIGTLinkBuildSettings.cmake
#  ${OpenIGTLink_BINARY_DIR}/OpenIGTLinkLibraryDepends.cmake
  ${OpenIGTLink_BINARY_DIR}/UseOpenIGTLink.cmake
  DESTINATION ${OpenIGTLink_INSTALL_PACKAGE_DIR}
  COMPONENT Development
  )

INSTALL(FILES
  ${OpenIGTLink_BINARY_DIR}/igtlConfigure.h
  DESTINATION ${OpenIGTLink_INSTALL_INCLUDE_DIR}
  COMPONENT Development
  )

INSTALL(FILES
  ${OpenIGTLink_BINARY_DIR}/igtl_typeconfig.h
  DESTINATION ${OpenIGTLink_INSTALL_INCLUDE_DIR}/igtlutil
  COMPONENT Development
  )

INSTALL(FILES
  ${OpenIGTLink_BINARY_DIR}/igtlTypeConfig.h
  DESTINATION ${OpenIGTLink_INSTALL_INCLUDE_DIR}
  COMPONENT Development
  )

#-----------------------------------------------------------------------------
# Add compiler flags OpenIGTLink needs to work on this platform.  This must be
# done AFTER the call to CMAKE_EXPORT_BUILD_SETTINGS.

SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenIGTLink_REQUIRED_C_FLAGS}")
SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenIGTLink_REQUIRED_CXX_FLAGS}")
SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${OpenIGTLink_REQUIRED_LINK_FLAGS}")
SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${OpenIGTLink_REQUIRED_LINK_FLAGS}")
SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} ${OpenIGTLink_REQUIRED_LINK_FLAGS}")


#-----------------------------------------------------------------------------
# Configure Subdirectories

ADD_SUBDIRECTORY( Source    )
ADD_SUBDIRECTORY( Testing   )
ADD_SUBDIRECTORY( Tools     )
#ADD_SUBDIRECTORY( Documents )

IF(OpenIGTLink_BUILD_EXAMPLES)
 ADD_SUBDIRECTORY( Examples )
ENDIF(OpenIGTLink_BUILD_EXAMPLES)



#-----------------------------------------------------------------------------
# Doxygen 

OPTION(BUILD_DOCUMENTATION "Build OpenIGTLink Documentation" OFF)

IF(BUILD_DOCUMENTATION)
  #SUBDIRS(Utilities/Doxygen)
  ADD_SUBDIRECTORY( Documents/Doxygen )
  CONFIGURE_FILE(${OpenIGTLink_SOURCE_DIR}/Utilities/Doxygen/doxygen.config.in
               ${OpenIGTLink_BINARY_DIR}/doxygen.config)

  CONFIGURE_FILE(${OpenIGTLink_SOURCE_DIR}/Utilities/Doxygen/igtldoxygen.pl.in
               ${OpenIGTLink_BINARY_DIR}/igtldoxygen.pl)
ENDIF(BUILD_DOCUMENTATION)

=== Documents/CMakeLists.txt ===
ADD_SUBDIRECTORY( Papers   )
ADD_SUBDIRECTORY( Protocol )

=== Examples/CMakeLists.txt ===
--- 
+++ 
@@ -13,6 +13,7 @@
       Imager
       Status
       Receiver
+      Thread
       )
 else(NOT OpenIGTLink_PLATFORM_QNX)
   SUBDIRS(

=== Source/CMakeLists.txt ===

# list of libraries
# Note: this part should be moved to OpenIGTLinkConfigPlatform.cmake
IF(OpenIGTLink_PLATFORM_WIN32) # for Windows
  SET(LINK_LIBS
    ws2_32
    wsock32
  )
ELSE(OpenIGTLink_PLATFORM_WIN32) # for POSIX-compatible OSs
  SET(LINK_LIBS
    m
    pthread
  )
  IF(OpenIGTLink_PLATFORM_QNX)
    SET(LINK_LIBS
      ${LINK_LIBS}
      c
      socket
    )
  ENDIF(OpenIGTLink_PLATFORM_QNX)
  IF(OpenIGTLink_PLATFORM_SUNOS)
    SET(LINK_LIBS
      ${LINK_LIBS}
      ${OpenIGTLink_STD_LINK_LIBRARIES}
    )
  ENDIF(OpenIGTLink_PLATFORM_SUNOS)
ENDIF(OpenIGTLink_PLATFORM_WIN32)


ADD_SUBDIRECTORY( igtlutil )

SET(OpenIGTLink_SOURCES
  igtlutil/igtl_header.c
  igtlutil/igtl_image.c
  igtlutil/igtl_transform.c
  igtlutil/igtl_status.c
  igtlutil/igtl_util.c
  igtlutil/igtl_position.c
  igtlClientSocket.cxx
  igtlConditionVariable.cxx
  igtlFastMutexLock.cxx
  igtlImageMessage.cxx
  igtlLightObject.cxx
  igtlMath.cxx
  igtlMessageBase.cxx
  igtlMultiThreader.cxx
  igtlMutexLock.cxx
  igtlOSUtil.cxx
  igtlObject.cxx
  igtlObjectFactoryBase.cxx
  igtlPositionMessage.cxx
  igtlServerSocket.cxx
  igtlSimpleFastMutexLock.cxx
  igtlSocket.cxx
  igtlStatusMessage.cxx
  igtlTimeStamp.cxx
  igtlTransformMessage.cxx
  )

ADD_LIBRARY(OpenIGTLink
  ${OpenIGTLink_SOURCES}
  )

TARGET_LINK_LIBRARIES(OpenIGTLink
  ${LINK_LIBS}
  )

SET_TARGET_PROPERTIES(OpenIGTLink PROPERTIES
  VERSION ${OpenIGTLink_VERSION_MAJOR}.${OpenIGTLink_VERSION_MINOR}.${OpenIGTLink_VERSION_PATCH}
  SOVERSION ${OpenIGTLink_VERSION_MAJOR}
)

FILE(GLOB __files1 "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
INSTALL(FILES ${__files1}
  DESTINATION ${OpenIGTLink_INSTALL_INCLUDE_DIR}
  COMPONENT Development)

FILE(GLOB __files2 "${CMAKE_CURRENT_SOURCE_DIR}/igtlutil/*.h")
INSTALL(FILES ${__files2}
  DESTINATION ${OpenIGTLink_INSTALL_INCLUDE_DIR}/igtlutil
  COMPONENT Development)

INSTALL(TARGETS OpenIGTLink
  RUNTIME DESTINATION ${OpenIGTLink_INSTALL_BIN_DIR} COMPONENT RuntimeLibraries
  LIBRARY DESTINATION ${OpenIGTLink_INSTALL_LIB_DIR} COMPONENT RuntimeLibraries
  ARCHIVE DESTINATION ${OpenIGTLink_INSTALL_LIB_DIR} COMPONENT Development)

=== Testing/CMakeLists.txt ===
ADD_SUBDIRECTORY( igtlutil )

ADD_EXECUTABLE(igtlSocketTest   igtlSocketTest.cxx)
ADD_EXECUTABLE(igtlMultiThreaderTest1   igtlMultiThreaderTest1.cxx)
ADD_EXECUTABLE(igtlMultiThreaderTest2   igtlMultiThreaderTest2.cxx)
ADD_EXECUTABLE(igtlMultiThreaderTest3   igtlMultiThreaderTest3.cxx)

INCLUDE_DIRECTORIES( ${OpenIGTLink_SOURCE_DIR}/Source )

TARGET_LINK_LIBRARIES(igtlSocketTest OpenIGTLink)
TARGET_LINK_LIBRARIES(igtlMultiThreaderTest1 OpenIGTLink)
TARGET_LINK_LIBRARIES(igtlMultiThreaderTest2 OpenIGTLink)
TARGET_LINK_LIBRARIES(igtlMultiThreaderTest3 OpenIGTLink)

ADD_TEST(igtlSocketTest ${OpenIGTLink_EXECUTABLE_PATH}/igtlSocketTest)
ADD_TEST(igtlMultiThreaderTest1 ${OpenIGTLink_EXECUTABLE_PATH}/igtlMultiThreaderTest1)
ADD_TEST(igtlMultiThreaderTest2 ${OpenIGTLink_EXECUTABLE_PATH}/igtlMultiThreaderTest2)
ADD_TEST(igtlMultiThreaderTest3 ${OpenIGTLink_EXECUTABLE_PATH}/igtlMultiThreaderTest3)

=== Documents/Papers/CMakeLists.txt ===
ADD_SUBDIRECTORY( InsightJournal2008 )

=== Documents/Protocol/CMakeLists.txt ===
#
#  Add here build instructions for Protocol documents.
#

=== Examples/Imager/CMakeLists.txt ===
PROJECT(Imager)

cmake_minimum_required(VERSION 2.4)
if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

find_package(OpenIGTLink REQUIRED)

include(${OpenIGTLink_USE_FILE})

ADD_EXECUTABLE(ImagerClient   ImagerClient.cxx)
TARGET_LINK_LIBRARIES(ImagerClient OpenIGTLink)

ADD_EXECUTABLE(ImagerServer   ImagerServer.cxx)
TARGET_LINK_LIBRARIES(ImagerServer OpenIGTLink)

=== Examples/Tracker/CMakeLists.txt ===
PROJECT(Tracker)

cmake_minimum_required(VERSION 2.4)
if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

find_package(OpenIGTLink REQUIRED)

include(${OpenIGTLink_USE_FILE})

ADD_EXECUTABLE(TrackerClient   TrackerClient.cxx)
TARGET_LINK_LIBRARIES(TrackerClient OpenIGTLink)
ADD_EXECUTABLE(TrackerServer   TrackerServer.cxx)
TARGET_LINK_LIBRARIES(TrackerServer OpenIGTLink)

ADD_EXECUTABLE(TrackerClient2   TrackerClient2.cxx)
TARGET_LINK_LIBRARIES(TrackerClient2 OpenIGTLink)
ADD_EXECUTABLE(TrackerServer2   TrackerServer2.cxx)
TARGET_LINK_LIBRARIES(TrackerServer2 OpenIGTLink)

=== Source/igtlutil/CMakeLists.txt ===
SET(IGTL_UTIL_PROTOCOL_VERSION "1")

if(OpenIGTLink_BUILD_SHARED_LIBS)
  set(igtlutil_BUILD_SHARED_LIBS ${OpenIGTLink_BUILD_SHARED_LIBS})
  
endif(OpenIGTLink_BUILD_SHARED_LIBS)

if(OpenIGTLink_BUILD_GENERATE_PIC)
  set(igtlutil_BUILD_GENERATE_PIC ${OpenIGTLink_BUILD_GENERATE_PIC})
  set(IGTLSTATIC 1)
endif(OpenIGTLink_BUILD_GENERATE_PIC)

SET(igtlutil_HEADS
  igtl_header.h
  igtl_image.h
  igtl_transform.h
  igtl_util.h
  igtl_types.h
  igtl_position.h
  )

SET(igtlutil_SOURCES
  igtl_header.c
  igtl_image.c
  igtl_transform.c
  igtl_util.c
#  igtl_position.c
  )       

ADD_LIBRARY(igtlutil
  ${igtlutil_SOURCES}
)

SET_TARGET_PROPERTIES(igtlutil PROPERTIES
  VERSION ${OpenIGTLink_VERSION_MAJOR}.${OpenIGTLink_VERSION_MINOR}.${OpenIGTLink_VERSION_PATCH}
  SOVERSION ${OpenIGTLink_VERSION_MAJOR}
)

#TARGET_LINK_LIBRARIES(igtlutil
#  ${LIBS}
#  )

=== Testing/igtlutil/CMakeLists.txt ===
ADD_EXECUTABLE(igtl_image_test igtl_image_test.c)
ADD_EXECUTABLE(igtl_header_test igtl_header_test.c)
ADD_EXECUTABLE(igtl_transform_test igtl_transform_test.c)
ADD_EXECUTABLE(igtl_status_test igtl_status_test.c)
ADD_EXECUTABLE(igtl_util_test igtl_util_test.c)


TARGET_LINK_LIBRARIES(igtl_image_test OpenIGTLink)
TARGET_LINK_LIBRARIES(igtl_header_test OpenIGTLink)
TARGET_LINK_LIBRARIES(igtl_transform_test OpenIGTLink)
TARGET_LINK_LIBRARIES(igtl_status_test OpenIGTLink)
TARGET_LINK_LIBRARIES(igtl_util_test OpenIGTLink)

ADD_TEST( igtl_image_test_01     ${OpenIGTLink_EXECUTABLE_PATH}/igtl_image_test )
ADD_TEST( igtl_header_test_01    ${OpenIGTLink_EXECUTABLE_PATH}/igtl_header_test )
ADD_TEST( igtl_transform_test_01 ${OpenIGTLink_EXECUTABLE_PATH}/igtl_transform_test )
ADD_TEST( igtl_status_test_01    ${OpenIGTLink_EXECUTABLE_PATH}/igtl_status_test )
ADD_TEST( igtl_util_test_01      ${OpenIGTLink_EXECUTABLE_PATH}/igtl_util_test )

=== Documents/Papers/InsightJournal2008/CMakeLists.txt ===
PROJECT(OpenIGTLinkInsightJournalPaper2008)

FIND_PACKAGE(LATEX)

IF(NOT PDFLATEX_COMPILER)
  MESSAGE("pdflatex compiler was not found. Please pass to advanced mode and provide its full path")
ENDIF(NOT PDFLATEX_COMPILER)

FIND_PACKAGE(Gnuplot)

#
# Set some directories that we use below.
#
SET(PLOT_DIR ${OpenIGTLinkInsightJournalPaper2008_BINARY_DIR})


#
# These are source files needed for the report generation.
#
SET(REPORT_SRCS
  algorithmic.sty
  algorithm.sty
  amssymb.sty
  fancyhdr.sty
  floatflt.sty
  fncychap.sty
  InsightArticle.cls
  InsightJournal.bib
  InsightJournal.ist
  InsightJournal.sty
  OpenIGTLinkIJ2008.tex
  times.sty
  picins.sty
  )

#
# This adds a custom command for each source file in REPORT_SRCS
# that copies the file from the source directory to the binary
# directory where the pdf will be generated.
#
FOREACH(SOURCE_FILE ${REPORT_SRCS})
   ADD_CUSTOM_COMMAND(
     OUTPUT   ${OpenIGTLinkInsightJournalPaper2008_BINARY_DIR}/${SOURCE_FILE}
     DEPENDS  ${OpenIGTLinkInsightJournalPaper2008_SOURCE_DIR}/${SOURCE_FILE}
     COMMAND ${CMAKE_COMMAND} -E copy_if_different ${OpenIGTLinkInsightJournalPaper2008_SOURCE_DIR}/${SOURCE_FILE} ${OpenIGTLinkInsightJournalPaper2008_BINARY_DIR}/${SOURCE_FILE}
    )
   SET(COPY_RESULTS ${COPY_RESULTS} ${OpenIGTLinkInsightJournalPaper2008_BINARY_DIR}/${SOURCE_FILE})
ENDFOREACH(SOURCE_FILE ${REPORT_SRCS})

#
# Add here the list of graphics that are generated at run time and must be
# inserted in the document.
#
SET(GRAPHICS_TO_BE_INSERTED "")

#
# This adds a custom target that generates OpenIGTLinkIJ2008.pdf
# This target depends on the list of copied files created
# with the custom command above and the Plots target.
#
ADD_CUSTOM_TARGET(OpenIGTLinkIJ2008 ALL 
   COMMAND ${PDFLATEX_COMPILER} 
        ${OpenIGTLinkInsightJournalPaper2008_SOURCE_DIR}/OpenIGTLinkIJ2008.tex 
        -output-directory ${OpenIGTLinkInsightJournalPaper2008_BINARY_DIR}
   COMMAND ${PDFLATEX_COMPILER} 
        ${OpenIGTLinkInsightJournalPaper2008_SOURCE_DIR}/OpenIGTLinkIJ2008.tex 
        -output-directory ${OpenIGTLinkInsightJournalPaper2008_BINARY_DIR}
   DEPENDS ${COPY_RESULTS} ${GRAPHICS_TO_BE_INSERTED}
   WORKING_DIRECTORY ${OpenIGTLinkInsightJournalPaper2008_BINARY_DIR}
   )
 
#  
# This adds a custom target that will display the report.
#   
IF(WIN32)
  SET(PDF_READER "c:\\Program Files\\Adobe\\Reader 8.0\\Reader\\AcroRd32.exe")
ELSE(WIN32)
  SET(PDF_READER "/usr/bin/acroread")
ENDIF(WIN32)

ADD_CUSTOM_TARGET(ViewReport ALL
  COMMAND ${CMAKE_COMMAND} -E echo ${OpenIGTLinkInsightJournalPaper2008_BINARY_DIR}/OpenIGTLinkIJ2008.pdf
#  COMMAND ${PDF_READER} 
#  ARGS ${OpenIGTLinkInsightJournalPaper2008_BINARY_DIR}/OpenIGTLinkIJ2008.pdf
)

=== debian/changelog ===
openigtlink (1.0.0~svn6270-1) unstable; urgency=low

  * new upstream snaphot

 -- Dominique Belhachemi <domibel@cs.tu-berlin.de>  Sat, 17 Apr 2010 07:42:13 -0400

openigtlink (1.0.0~svn5602-1) unstable; urgency=low

  * Switch to dpkg-source 3.0 (quilt) format
  * Update to Debian Policy 3.8.4 (no changes)
  * fixed multithreading tests

 -- Dominique Belhachemi <domibel@cs.tu-berlin.de>  Wed, 14 Apr 2010 09:55:06 -0400

openigtlink (1.0.0~svn5516-1) unstable; urgency=low

  * switched from dpatch to quilt
  * Bump Standards-Version to 3.8.3
    added DEB_HOST_ARCH_CPU and DEB_HOST_ARCH_OS
  * updated watch file
  * updated debian/get-orig-source
  * added debian/README.source

 -- Dominique Belhachemi <domibel@cs.tu-berlin.de>  Mon, 11 Jan 2010 20:40:59 -0500

openigtlink (1.0.0~svn3987-1) unstable; urgency=low

  * new snapshot
  * fixed configure issue
  * added watch file (Closes: #520529)
  * *.cmake files are going to be installed into
    /usr/lib/openigtlink/ instead of /usr/lib/igtl/ so that 
    CMake's find_package() has a chance to find it in Config mode

 -- Dominique Belhachemi <domibel@cs.tu-berlin.de>  Thu, 26 Mar 2009 19:45:05 -0400

openigtlink (1.0.0~svn3601-1) unstable; urgency=low

  * Initial release (Closes: #509309)

 -- Dominique Belhachemi <domibel@cs.tu-berlin.de>  Sun, 01 Feb 2009 00:11:19 -0600

=== debian/control ===
Source: openigtlink
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
DM-Upload-Allowed: yes
Uploaders: Dominique Belhachemi <domibel@cs.tu-berlin.de>
Build-Depends: debhelper (>= 7), quilt, cmake
Build-Depends-Indep: doxygen (>= 1.6.2), graphviz, gnuplot-nox, texlive, ghostscript
Standards-Version: 3.8.4
Vcs-Browser: http://svn.debian.org/wsvn/debian-science/packages/openigtlink/trunk/?rev=0&sc=0
Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/openigtlink/trunk/
Section: libs
Homepage: http://www.na-mic.org/Wiki/index.php/OpenIGTLink


Package: libopenigtlink1-dev
Section: libdevel
Architecture: any
Depends: libopenigtlink1 (= ${binary:Version}), ${misc:Depends}
Description: Open IGT Link is a simple network protocol - development
 Open IGT Link is a simple network protocol intended for trackers,
 robots and other devices to send data to the main application.
 Some devices might also accept commands.
 .
 This package contains the development files needed to build
 your own IGT applications.


Package: libopenigtlink1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Open IGT Link is a simple network protocol - runtime
 Open IGT Link is a simple network protocol intended for trackers,
 robots and other devices to send data to the main application. 
 Some devices might also accept commands.
 .
 This package contains library files for OpenIGTLink.
 

Package: openigtlink-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Open IGT Link is a simple network protocol - documentation
 Open IGT Link is a simple network protocol intended for trackers,
 robots and other devices to send data to the main application.
 Some devices might also accept commands.
 .
 This package contains documentation files for OpenIGTLink.


Package: openigtlink-examples
Section: doc
Suggests: libopenigtlink1-dev
Architecture: all
Depends: ${misc:Depends}
Description: Open IGT Link is a simple network protocol - examples
 Open IGT Link is a simple network protocol intended for trackers,
 robots and other devices to send data to the main application.
 Some devices might also accept commands.
 .
 This package contains examples from the OpenIGTLink source.

=== debian/rules ===
#!/usr/bin/make -f

PACKAGE=openigtlink

DEB_SOURCE_PACKAGE:=$(PACKAGE)
include /usr/share/quilt/quilt.make

# set the number of build jobs
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
        JOBS := -j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

DEB_HOST_ARCH_CPU := $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU 2>/dev/null)
DEB_HOST_ARCH_OS  := $(shell dpkg-architecture -qDEB_HOST_ARCH_OS 2>/dev/null)
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=0

STATIC_BUILD_PATH = DEB_build_static
SHARED_BUILD_PATH = DEB_build_shared

CMAKE_FLAGS = -DCMAKE_INSTALL_PREFIX:PATH=/usr \
              -DCMAKE_CXX_FLAGS="-Wno-deprecated" \
              -DCMAKE_VERBOSE_MAKEFILE=$(DH_VERBOSE) \
              -DCMAKE_SHARED_LINKER_FLAGS="-Wl,--as-needed" \
              -DCMAKE_EXE_LINKER_FLAGS="-Wl,--as-needed" \
              -DCMAKE_SKIP_RPATH:BOOL=ON \
              -DBUILD_DOCUMENTATION:BOOL=ON \
              -DBUILD_TESTING:BOOL=ON \
              -DBUILD_EXAMPLES:BOOL=OFF \

get-orig-source:
	/bin/sh $(CURDIR)/debian/get-orig-source

configure: configure-stamp

configure-stamp: $(QUILT_STAMPFN)
	dh_testdir

        # Add here commands to configure the package.
	echo DEB_HOST_ARCH_CPU = ${DEB_HOST_ARCH_CPU}
	echo DEB_HOST_ARCH_OS  = ${DEB_HOST_ARCH_OS}
	echo DEB_HOST_ARCH     = ${DEB_HOST_ARCH}


	if [ ! -d $(STATIC_BUILD_PATH) ]; then mkdir $(STATIC_BUILD_PATH); fi

	cd $(STATIC_BUILD_PATH) \
            && cmake $(CURDIR) $(CMAKE_FLAGS) -DBUILD_SHARED_LIBS:BOOL=OFF


	if [ ! -d $(SHARED_BUILD_PATH) ]; then mkdir $(SHARED_BUILD_PATH); fi

	cd $(SHARED_BUILD_PATH) \
            && cmake $(CURDIR) $(CMAKE_FLAGS) -DBUILD_SHARED_LIBS:BOOL=ON

	touch $@


build: build-arch

build-arch: build-arch-stamp
build-arch-stamp: configure-stamp
	dh_testdir

	# Add here commands to compile the package.

        # build static libs
	$(MAKE) $(JOBS) -C $(STATIC_BUILD_PATH)

	# perform tests ('-' ignores return values)
	- cd $(STATIC_BUILD_PATH) && ctest -VV

	# build shared libs and binaries
	$(MAKE) $(JOBS) -C $(SHARED_BUILD_PATH)

	touch $@

build-indep: build-indep-stamp
build-indep-stamp: configure-stamp
	dh_testdir

#	$(MAKE) $(JOBS) DoxygenDoc -C $(STATIC_BUILD_PATH)
	doxygen -u $(STATIC_BUILD_PATH)/doxygen.config
	doxygen $(STATIC_BUILD_PATH)/doxygen.config

	touch $@


clean: clean-patched unpatch

clean-patched:
	dh_testdir
	dh_testroot

	# Add here commands to clean up after the build process.
	rm -rf $(STATIC_BUILD_PATH)
	rm -rf $(SHARED_BUILD_PATH)

	dh_clean

install: install-indep install-arch

install-arch: build-arch
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	# Add here commands to install the package into debian/tmp
	
	# install binaries and shared libs
	$(MAKE) $(JOBS) -C $(SHARED_BUILD_PATH) install DESTDIR=$(CURDIR)/debian/tmp


        # install static libs
	cd $(STATIC_BUILD_PATH)/bin/ \
                && cp lib*.a $(CURDIR)/debian/tmp/usr/lib/


	# install development files
	dh_install -plibopenigtlink1-dev  debian/tmp/usr/include/openigtlink/*            usr/include/openigtlink


	# install libs and *cmake files
	dh_install -plibopenigtlink1-dev  debian/tmp/usr/lib/*.a                   usr/lib
	dh_install -plibopenigtlink1-dev  debian/tmp/usr/lib/*.so                  usr/lib
	dh_install -plibopenigtlink1-dev  debian/tmp/usr/lib/openigtlink/*.cmake   usr/lib/openigtlink

	dh_install -plibopenigtlink1      debian/tmp/usr/lib/*.so.*                usr/lib



install-indep: build-indep
	dh_install -popenigtlink-doc       $(STATIC_BUILD_PATH)/Documents/Doxygen/html    usr/share/doc/openigtlink-doc
	dh_installexamples -popenigtlink-examples Examples/*



# Build architecture-dependent files here.
binary-common:
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_installexamples
	dh_install --sourcedir=$(CURDIR)/debian/tmp
#	dh_install
#	dh_installmenu
	dh_installman
	dh_link
	dh_strip
	dh_compress -X"openigtlink-examples/examples"
	dh_fixperms
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb


# Build architecture independant packages using the common target.
binary-indep: build-indep install-indep
	$(MAKE) -f debian/rules DH_OPTIONS=-i binary-common


# Build architecture dependant packages using the common target.
binary-arch: build-arch install-arch
	$(MAKE) -f debian/rules DH_OPTIONS=-s binary-common


binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install install-indep install-arch configure

## openigtlink 1.9.2~svn7468

=== CMakeLists.txt ===
--- 
+++ 
@@ -12,9 +12,17 @@
 #-----------------------------------------------------------------------------
 # OpenIGTlink version number.
 SET(OpenIGTLink_VERSION_MAJOR "1")
-SET(OpenIGTLink_VERSION_MINOR "0")
-SET(OpenIGTLink_VERSION_PATCH "0")
-
+SET(OpenIGTLink_VERSION_MINOR "9")
+SET(OpenIGTLink_VERSION_PATCH "2")
+
+
+option(OpenIGTLink_PROTOCOL_VERSION_2 "Build Library for Protocol Version 2" OFF)
+
+IF(OpenIGTLink_PROTOCOL_VERSION_2)
+  SET(OpenIGTLink_PROTOCOL_VERSION "2")
+ELSE(OpenIGTLink_PROTOCOL_VERSION_2)
+  SET(OpenIGTLink_PROTOCOL_VERSION "1")
+ENDIF(OpenIGTLink_PROTOCOL_VERSION_2)
 
 
 #-----------------------------------------------------------------------------
@@ -45,6 +53,11 @@
 
 SET(OpenIGTLink_LIBRARY_PATH "${LIBRARY_OUTPUT_PATH}")
 SET(OpenIGTLink_EXECUTABLE_PATH "${EXECUTABLE_OUTPUT_PATH}")
+
+SET(OpenIGTLink_CMAKE_DIR "${OpenIGTLink_SOURCE_DIR}/CMake")
+SET(CMAKE_MODULE_PATH "${OpenIGTLink_SOURCE_DIR}/CMake" ${CMAKE_MODULE_PATH})
+
+
 
 
 #-----------------------------------------------------------------------------
@@ -110,8 +123,16 @@
 INCLUDE (FindThreads)
 
 IF(CMAKE_COMPILER_IS_GNUCXX)
-  SET(OpenIGTLink_REQUIRED_C_FLAGS "${OpenIGTLink_REQUIRED_C_FLAGS} -w")
-  SET(OpenIGTLink_REQUIRED_CXX_FLAGS "${OpenIGTLink_REQUIRED_CXX_FLAGS} -ftemplate-depth-50")
+
+  # '-fno-tree-vectorize' option is added to avoid segmentation fault that occurs in
+  # igtl_image_convert_byte_order() (Source/igtlutil/igtl_image.c) built with 'Release'
+  # option on 64-bit Linux. 
+  INCLUDE (CheckCXXCompilerFlag)
+  CHECK_CXX_COMPILER_FLAG("-fno-tree-vectorize" OpenIGTLink_GNUCXX_TREE_VECTORIZE_SUPPORT)
+  IF (OpenIGTLink_GNUCXX_TREE_VECTORIZE_SUPPORT)
+    SET(OpenIGTLink_REQUIRED_C_FLAGS "${OpenIGTLink_REQUIRED_C_FLAGS} -w -fno-tree-vectorize")
+    SET(OpenIGTLink_REQUIRED_CXX_FLAGS "${OpenIGTLink_REQUIRED_CXX_FLAGS} -ftemplate-depth-50 -fno-tree-vectorize")
+  ENDIF (OpenIGTLink_GNUCXX_TREE_VECTORIZE_SUPPORT)
 
   # If the library is built as a static library, pass -fPIC option to the compiler
   IF(OpenIGTLink_BUILD_GENERATE_PIC)
@@ -164,6 +185,14 @@
 
 
 #-----------------------------------------------------------------------------
+# Platform configuration tests.
+
+# Socket tests etc.
+INCLUDE(${OpenIGTLink_CMAKE_DIR}/OpenIGTLinkCMakeTests.cmake)
+
+
+
+#-----------------------------------------------------------------------------
 # Generate Configuration Header files.
 
 include (${OpenIGTLink_SOURCE_DIR}/OpenIGTLinkConfigPlatform.cmake)
@@ -199,6 +228,7 @@
   ${OpenIGTLink_BINARY_DIR}/OpenIGTLinkBuildSettings.cmake
 #  ${OpenIGTLink_BINARY_DIR}/OpenIGTLinkLibraryDepends.cmake
   ${OpenIGTLink_BINARY_DIR}/UseOpenIGTLink.cmake
+  ${OpenIGTLink_BINARY_DIR}/Utilities/OpenIGTLinkConfig.cmake
   DESTINATION ${OpenIGTLink_INSTALL_PACKAGE_DIR}
   COMPONENT Development
   )
@@ -211,7 +241,7 @@
 
 INSTALL(FILES
   ${OpenIGTLink_BINARY_DIR}/igtl_typeconfig.h
-  DESTINATION ${OpenIGTLink_INSTALL_INCLUDE_DIR}/igtlutil
+  DESTINATION ${OpenIGTLink_INSTALL_INCLUDE_DIR}
   COMPONENT Development
   )

=== Examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.4)

#
# Examples
#


SET(EXAMPLE_DIRS
  Tracker
  Imager
  Status
  Receiver
  Thread
  )

if (${OpenIGTLink_PROTOCOL_VERSION} STREQUAL "2")
  SET(EXAMPLE_DIRS
    ${EXAMPLE_DIRS}
    ImageMeta
    Point
    TrackingData
    QuaternionTrackingData
    ImageDatabaseServer
    String
    Bind
    )
endif (${OpenIGTLink_PROTOCOL_VERSION} STREQUAL "2")


## Imager program isn't supported by QNX

if(NOT OpenIGTLink_PLATFORM_QNX)
  SUBDIRS(
    ${EXAMPLE_DIRS}  
    )
else(NOT OpenIGTLink_PLATFORM_QNX)
  SUBDIRS(
      Tracker
      Status
      Receiver
      )
endif(NOT OpenIGTLink_PLATFORM_QNX)

=== Source/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,3 @@
-
 # list of libraries
 # Note: this part should be moved to OpenIGTLinkConfigPlatform.cmake
 IF(OpenIGTLink_PLATFORM_WIN32) # for Windows
@@ -57,6 +56,100 @@
   igtlTransformMessage.cxx
   )
 
+SET(OpenIGTLink_INCLUDE_FILES
+  igtlutil/igtl_header.h
+  igtlutil/igtl_image.h
+  igtlutil/igtl_position.h
+  igtlutil/igtl_transform.h
+  igtlutil/igtl_types.h
+  igtlutil/igtl_util.h
+  igtlClientSocket.h
+  igtlConditionVariable.h
+  igtlCreateObjectFunction.h
+  igtlFastMutexLock.h
+  igtlImageMessage.h
+  igtlLightObject.h
+  igtlMacro.h
+  igtlMath.h
+  igtlMessageBase.h
+  igtlMessageHeader.h
+  igtlMultiThreader.h
+  igtlMutexLock.h
+  igtlObjectFactory.h
+  igtlOSUtil.h
+  igtlObject.h
+  igtlObjectFactoryBase.h
+  igtlPositionMessage.h
+  igtlServerSocket.h
+  igtlSimpleFastMutexLock.h
+  igtlSmartPointer.h
+  igtlSocket.h
+  igtlStatusMessage.h
+  igtlTimeStamp.h
+  igtlTransformMessage.h
+  igtlTypes.h
+  igtlWin32Header.h
+  igtlWindows.h
+)
+
+
+if (${OpenIGTLink_PROTOCOL_VERSION} STREQUAL "2")
+  SET(OpenIGTLink_SOURCES
+    ${OpenIGTLink_SOURCES}
+    igtlutil/igtl_colortable.c
+    igtlutil/igtl_imgmeta.c
+    igtlutil/igtl_lbmeta.c
+    igtlutil/igtl_point.c
+    igtlutil/igtl_tdata.c
+    igtlutil/igtl_qtdata.c
+    igtlutil/igtl_trajectory.c
+    igtlutil/igtl_unit.c
+    igtlutil/igtl_sensor.c
+    igtlutil/igtl_string.c
+    igtlutil/igtl_ndarray.c
+    igtlutil/igtl_bind.c
+    igtlColorTableMessage.cxx
+    igtlImageMetaMessage.cxx
+    igtlLabelMetaMessage.cxx
+    igtlPointMessage.cxx
+    igtlTrackingDataMessage.cxx
+    igtlQuaternionTrackingDataMessage.cxx
+    igtlTrajectoryMessage.cxx
+    igtlStringMessage.cxx
+    igtlUnit.cxx
+    igtlSensorMessage.cxx
+    igtlBindMessage.cxx
+    igtlNDArrayMessage.cxx
+    )
+  SET(OpenIGTLink_INCLUDE_FILES
+    ${OpenIGTLink_INCLUDE_FILES}
+    igtlutil/igtl_colortable.h
+    igtlutil/igtl_imgmeta.h
+    igtlutil/igtl_lbmeta.h
+    igtlutil/igtl_point.h
+    igtlutil/igtl_tdata.h
+    igtlutil/igtl_qtdata.h
+    igtlutil/igtl_trajectory.h
+    igtlutil/igtl_unit.h
+    igtlutil/igtl_sensor.h
+    igtlutil/igtl_string.h
+    igtlutil/igtl_ndarray.h
+    igtlutil/igtl_bind.h
+    igtlColorTableMessage.h
+    igtlImageMetaMessage.h
+    igtlLabelMetaMessage.h
+    igtlPointMessage.h
+    igtlTrackingDataMessage.h
+    igtlQuaternionTrackingDataMessage.h
+    igtlTrajectoryMessage.h
+    igtlStringMessage.h
+    igtlUnit.h
+    igtlSensorMessage.h
+    igtlBindMessage.h
+    igtlNDArrayMessage.h
+    )
+endif (${OpenIGTLink_PROTOCOL_VERSION} STREQUAL "2")
+
 ADD_LIBRARY(OpenIGTLink
   ${OpenIGTLink_SOURCES}
   )
@@ -70,14 +163,18 @@
   SOVERSION ${OpenIGTLink_VERSION_MAJOR}
 )
 
-FILE(GLOB __files1 "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
-INSTALL(FILES ${__files1}
+#FILE(GLOB __files1 "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
+#INSTALL(FILES ${__files1}
+#  DESTINATION ${OpenIGTLink_INSTALL_INCLUDE_DIR}
+#  COMPONENT Development)
+#
+#FILE(GLOB __files2 "${CMAKE_CURRENT_SOURCE_DIR}/igtlutil/*.h")
+#INSTALL(FILES ${__files2}
+#  DESTINATION ${OpenIGTLink_INSTALL_INCLUDE_DIR}/igtlutil
+#  COMPONENT Development)
+
+INSTALL(FILES ${OpenIGTLink_INCLUDE_FILES}
   DESTINATION ${OpenIGTLink_INSTALL_INCLUDE_DIR}
-  COMPONENT Development)
-
-FILE(GLOB __files2 "${CMAKE_CURRENT_SOURCE_DIR}/igtlutil/*.h")
-INSTALL(FILES ${__files2}
-  DESTINATION ${OpenIGTLink_INSTALL_INCLUDE_DIR}/igtlutil
   COMPONENT Development)
 
 INSTALL(TARGETS OpenIGTLink

=== Examples/Point/CMakeLists.txt ===
PROJECT(Point)

cmake_minimum_required(VERSION 2.4)
if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

find_package(OpenIGTLink REQUIRED)

include(${OpenIGTLink_USE_FILE})

ADD_EXECUTABLE(PointClient   PointClient.cxx)
TARGET_LINK_LIBRARIES(PointClient OpenIGTLink)

ADD_EXECUTABLE(PointServer   PointServer.cxx)
TARGET_LINK_LIBRARIES(PointServer OpenIGTLink)

=== Examples/String/CMakeLists.txt ===
PROJECT(String)

cmake_minimum_required(VERSION 2.4)
if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

find_package(OpenIGTLink REQUIRED)

include(${OpenIGTLink_USE_FILE})

ADD_EXECUTABLE(StringClient   StringClient.cxx)
TARGET_LINK_LIBRARIES(StringClient OpenIGTLink)

ADD_EXECUTABLE(StringServer   StringServer.cxx)
TARGET_LINK_LIBRARIES(StringServer OpenIGTLink)

=== Source/igtlutil/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,5 @@
-SET(IGTL_UTIL_PROTOCOL_VERSION "1")
+#SET(IGTL_UTIL_PROTOCOL_VERSION "1")
+#SET(IGTL_UTIL_PROTOCOL_VERSION ${OpenIGTLink_PROTOCOL_VERSION})
 
 if(OpenIGTLink_BUILD_SHARED_LIBS)
   set(igtlutil_BUILD_SHARED_LIBS ${OpenIGTLink_BUILD_SHARED_LIBS})
@@ -13,19 +14,55 @@
 SET(igtlutil_HEADS
   igtl_header.h
   igtl_image.h
+  igtl_position.h
   igtl_transform.h
+  igtl_types.h
   igtl_util.h
-  igtl_types.h
-  igtl_position.h
   )
 
 SET(igtlutil_SOURCES
   igtl_header.c
   igtl_image.c
+  igtl_position.c
   igtl_transform.c
   igtl_util.c
-#  igtl_position.c
   )       
+
+
+if (${OpenIGTLink_PROTOCOL_VERSION} STREQUAL "2")
+  SET(igtlutil_HEADS
+    ${igtlutil_HEADS}
+    igtl_colortable.h
+    igtl_imgmeta.h
+    igtl_lbmeta.h
+    igtl_point.h
+    igtl_tdata.h
+    igtl_qtdata.h
+    igtl_trajectory.h
+    igtl_unit.h
+    igtl_sensor.h
+    igtl_string.h
+    igtl_ndarray.h
+    igtl_bind.h
+#    igtl_polydata.h
+    )
+  SET(igtlutil_SOURCES
+    ${igtlutil_SOURCES}
+    igtl_colortable.c
+    igtl_imgmeta.c
+    igtl_lbmeta.c
+    igtl_point.c
+    igtl_tdata.c
+    igtl_qtdata.c
+    igtl_trajectory.c
+    igtl_unit.c
+    igtl_sensor.c
+    igtl_string.c
+    igtl_ndarray.c
+    igtl_bind.c
+#    igtl_polydata.c
+    )
+endif (${OpenIGTLink_PROTOCOL_VERSION} STREQUAL "2")
 
 ADD_LIBRARY(igtlutil
   ${igtlutil_SOURCES}

=== Testing/igtlutil/CMakeLists.txt ===
find_package(OpenIGTLink REQUIRED)
include(${OpenIGTLink_USE_FILE})

ADD_EXECUTABLE(igtl_image_test igtl_image_test.c)
ADD_EXECUTABLE(igtl_header_test igtl_header_test.c)
ADD_EXECUTABLE(igtl_transform_test igtl_transform_test.c)
ADD_EXECUTABLE(igtl_status_test igtl_status_test.c)
ADD_EXECUTABLE(igtl_util_test igtl_util_test.c)
ADD_EXECUTABLE(igtl_position_test igtl_position_test.c)

if (${OpenIGTLink_PROTOCOL_VERSION} STREQUAL "2")
  ADD_EXECUTABLE(igtl_colortable_test igtl_colortable_test.c)
  ADD_EXECUTABLE(igtl_imgmeta_test igtl_imgmeta_test.c)
  ADD_EXECUTABLE(igtl_lbmeta_test igtl_lbmeta_test.c)
  ADD_EXECUTABLE(igtl_point_test igtl_point_test.c)
  ADD_EXECUTABLE(igtl_tdata_test igtl_tdata_test.c)
  ADD_EXECUTABLE(igtl_trajectory_test igtl_trajectory_test.c)
  ADD_EXECUTABLE(igtl_sensor_test igtl_sensor_test.c)
  ADD_EXECUTABLE(igtl_string_test igtl_string_test.c)
  ADD_EXECUTABLE(igtl_bind_test igtl_bind_test.c)
  ADD_EXECUTABLE(igtl_ndarray_test igtl_ndarray_test.c)
endif (${OpenIGTLink_PROTOCOL_VERSION} STREQUAL "2")

TARGET_LINK_LIBRARIES(igtl_image_test OpenIGTLink)
TARGET_LINK_LIBRARIES(igtl_header_test OpenIGTLink)
TARGET_LINK_LIBRARIES(igtl_transform_test OpenIGTLink)
TARGET_LINK_LIBRARIES(igtl_status_test OpenIGTLink)
TARGET_LINK_LIBRARIES(igtl_util_test OpenIGTLink)
TARGET_LINK_LIBRARIES(igtl_position_test OpenIGTLink)

if (${OpenIGTLink_PROTOCOL_VERSION} STREQUAL "2")
  TARGET_LINK_LIBRARIES(igtl_colortable_test OpenIGTLink)
  TARGET_LINK_LIBRARIES(igtl_imgmeta_test OpenIGTLink)
  TARGET_LINK_LIBRARIES(igtl_lbmeta_test OpenIGTLink)
  TARGET_LINK_LIBRARIES(igtl_point_test OpenIGTLink)
  TARGET_LINK_LIBRARIES(igtl_tdata_test OpenIGTLink)
  TARGET_LINK_LIBRARIES(igtl_trajectory_test OpenIGTLink)
  TARGET_LINK_LIBRARIES(igtl_sensor_test OpenIGTLink)
  TARGET_LINK_LIBRARIES(igtl_string_test OpenIGTLink)
  TARGET_LINK_LIBRARIES(igtl_bind_test OpenIGTLink)
  TARGET_LINK_LIBRARIES(igtl_ndarray_test OpenIGTLink)
endif (${OpenIGTLink_PROTOCOL_VERSION} STREQUAL "2")


ADD_TEST( igtl_image_test_01      ${OpenIGTLink_EXECUTABLE_PATH}/igtl_image_test )
ADD_TEST( igtl_header_test_01     ${OpenIGTLink_EXECUTABLE_PATH}/igtl_header_test )
ADD_TEST( igtl_transform_test_01  ${OpenIGTLink_EXECUTABLE_PATH}/igtl_transform_test )
ADD_TEST( igtl_status_test_01     ${OpenIGTLink_EXECUTABLE_PATH}/igtl_status_test )
ADD_TEST( igtl_util_test_01       ${OpenIGTLink_EXECUTABLE_PATH}/igtl_util_test )
ADD_TEST( igtl_position_test_01   ${OpenIGTLink_EXECUTABLE_PATH}/igtl_position_test )

if (${OpenIGTLink_PROTOCOL_VERSION} STREQUAL "2")
  ADD_TEST( igtl_colortable_test_01 ${OpenIGTLink_EXECUTABLE_PATH}/igtl_colortable_test )
  ADD_TEST( igtl_imgmeta_test_01    ${OpenIGTLink_EXECUTABLE_PATH}/igtl_imgmeta_test )
  ADD_TEST( igtl_lbmeta_test_01     ${OpenIGTLink_EXECUTABLE_PATH}/igtl_lbmeta_test )
  ADD_TEST( igtl_point_test_01      ${OpenIGTLink_EXECUTABLE_PATH}/igtl_point_test )
  ADD_TEST( igtl_tdata_test_01      ${OpenIGTLink_EXECUTABLE_PATH}/igtl_tdata_test )
  ADD_TEST( igtl_trajectory_test_01 ${OpenIGTLink_EXECUTABLE_PATH}/igtl_trajectory_test )
  ADD_TEST( igtl_sensor_test_01     ${OpenIGTLink_EXECUTABLE_PATH}/igtl_sensor_test )
  ADD_TEST( igtl_string_test_01     ${OpenIGTLink_EXECUTABLE_PATH}/igtl_string_test )
  ADD_TEST( igtl_bind_test_01       ${OpenIGTLink_EXECUTABLE_PATH}/igtl_bind_test )
  ADD_TEST( igtl_ndarray_test_01    ${OpenIGTLink_EXECUTABLE_PATH}/igtl_ndarray_test )
endif (${OpenIGTLink_PROTOCOL_VERSION} STREQUAL "2")

=== debian/changelog ===
openigtlink (1.9.2~svn7468-2) experimental; urgency=low

  * Use OpenIGTLink_PROTOCOL_VERSION_2 in experimental

 -- Dominique Belhachemi <domibel@debian.org>  Tue, 26 Apr 2011 20:20:04 -0400

openigtlink (1.9.2~svn7468-1) unstable; urgency=low

  * Fixed build problems on hurd and kfreebsd

 -- Dominique Belhachemi <domibel@debian.org>  Tue, 26 Apr 2011 19:05:05 -0400

openigtlink (1.9.2~svn7380-2) unstable; urgency=low

  * Removed DEB_DH_STRIP_ARGS variable
  * Activated extra verbose test output
  * Moved doxygen build commands to install/openigtlink-doc:: target

 -- Dominique Belhachemi <domibel@debian.org>  Sun, 17 Apr 2011 12:21:33 -0400

openigtlink (1.9.2~svn7380-1) unstable; urgency=low

  * New upstream version 1.9.2
  * Added debug package libopenigtlink1.9-dbg
  * Use CDBS
  * Bump compat level to 8

 -- Dominique Belhachemi <domibel@debian.org>  Sat, 02 Apr 2011 23:34:10 -0400

openigtlink (1.9.1~svn7162-1) unstable; urgency=low

  * new upstream snapshot
  * removed non-free Documents
  * bump Standard-Version to 3.9.1 (no changes required)
  * build-depend on doxygen-latex (Closes: #616272)
  * Bump SONAME to 1.9
  * removed quilt's patch/unpatch logic
  * removed debian/README.source

 -- Dominique Belhachemi <domibel@debian.org>  Thu, 10 Mar 2011 07:58:53 -0500

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,10 @@
 Priority: optional
 Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
 DM-Upload-Allowed: yes
-Uploaders: Dominique Belhachemi <domibel@cs.tu-berlin.de>
-Build-Depends: debhelper (>= 7), quilt, cmake
-Build-Depends-Indep: doxygen (>= 1.6.2), graphviz, gnuplot-nox, texlive, ghostscript
-Standards-Version: 3.8.4
+Uploaders: Dominique Belhachemi <domibel@debian.org>
+Build-Depends: debhelper (>= 8), cmake, cdbs, quilt
+Build-Depends-Indep: doxygen-latex
+Standards-Version: 3.9.1
 Vcs-Browser: http://svn.debian.org/wsvn/debian-science/packages/openigtlink/trunk/?rev=0&sc=0
 Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/openigtlink/trunk/
 Section: libs
@@ -15,7 +15,7 @@
 Package: libopenigtlink1-dev
 Section: libdevel
 Architecture: any
-Depends: libopenigtlink1 (= ${binary:Version}), ${misc:Depends}
+Depends: libopenigtlink1.9 (= ${binary:Version}), ${misc:Depends}
 Description: Open IGT Link is a simple network protocol - development
  Open IGT Link is a simple network protocol intended for trackers,
  robots and other devices to send data to the main application.
@@ -25,7 +25,7 @@
  your own IGT applications.
 
 
-Package: libopenigtlink1
+Package: libopenigtlink1.9
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Open IGT Link is a simple network protocol - runtime
@@ -35,6 +35,21 @@
  .
  This package contains library files for OpenIGTLink.
  
+
+Package: libopenigtlink1.9-dbg
+Architecture: any
+Section: debug
+Priority: extra
+Depends:
+    libopenigtlink1.9 (= ${binary:Version}),
+    ${misc:Depends}
+Description: debugging symbols for libopenigtlink1.9
+ Open IGT Link is a simple network protocol intended for trackers,
+ robots and other devices to send data to the main application.
+ Some devices might also accept commands.
+ .
+ This package contains the debugging symbols for libopenigtlink1.9.
+
 
 Package: openigtlink-doc
 Section: doc
@@ -59,4 +74,5 @@
  Some devices might also accept commands.
  .
  This package contains examples from the OpenIGTLink source.
-
+ .
+ Consult /usr/share/doc/libopenigtlink1-dev/README.Debian for details.

=== debian/rules ===
#!/usr/bin/make -f

DH_VERBOSE=1

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/cmake.mk
include /usr/share/cdbs/1/rules/patchsys-quilt.mk

DEB_CMAKE_EXTRA_FLAGS = \
        -DCMAKE_INSTALL_PREFIX:PATH=/usr \
        -DCMAKE_BUILD_TYPE:STRING=Release \
        -DCMAKE_SKIP_RPATH:BOOL=ON \
        -DBUILD_SHARED_LIBS:BOOL=ON \
        -DBUILD_DOCUMENTATION:BOOL=ON \
        -DBUILD_TESTING:BOOL=ON \
        -DBUILD_EXAMPLES:BOOL=OFF \
        -DOpenIGTLink_PROTOCOL_VERSION_2:BOOL=ON \
        -DCMAKE_VERBOSE_MAKEFILE=$(DH_VERBOSE) \


build/libopenigtlink1.9::
	- cd $(DEB_BUILDDIR) && LD_LIBRARY_PATH=`pwd`/bin:$$LD_LIBRARY_PATH ctest -VV

install/libopenigtlink1.9::
	dh_install -plibopenigtlink1.9     debian/tmp/usr/lib/*.so.*                usr/lib

install/libopenigtlink1-dev::
	dh_install -plibopenigtlink1-dev   debian/tmp/usr/include/openigtlink/*     usr/include/openigtlink
	dh_install -plibopenigtlink1-dev   debian/tmp/usr/lib/*.so                  usr/lib
	dh_install -plibopenigtlink1-dev   debian/tmp/usr/lib/openigtlink/*.cmake   usr/lib/openigtlink

install/openigtlink-examples::
	dh_installexamples -popenigtlink-examples Examples/*

# the first two lines have been moved from build/openigtlink-doc:: because of build errors on all architectures
# e.g. https://buildd.debian.org/fetch.cgi?pkg=openigtlink&arch=armel&ver=1.9.2~svn7380-1&stamp=1303034727&file=log
install/openigtlink-doc::
	doxygen -u $(DEB_BUILDDIR)/doxygen.config
	doxygen $(DEB_BUILDDIR)/doxygen.config
	dh_install -popenigtlink-doc       $(DEB_BUILDDIR)/Documents/Doxygen/html   usr/share/doc/openigtlink-doc


get-orig-source:
	/bin/sh $(CURDIR)/debian/get-orig-source
